#!/usr/bin/perl
#---------------------------------------
# client_db_admin.pl
# 
# ٤Ƥδоݤ˥ޥɤդ륹ץ
# ڽ񼰡
#  client_db_admin.pl command p1 p2 ...
#         add command : p1 = ip ,p2 = group, p3 = type, p4 = config
#         del command : p1 = ip
#         type command : p1 = ip ,p2 = type
#         dump command : p1 = ip
#         test command : none
#	  list command : none
#	  db_dump command : p1 = DBname(client_db,group_db,config_db,users_db,...)
#	  add_list command : p1 = filename
#
use Socket;
use Fcntl;
use AnyDBM_File;

$command = shift;
$manager_dir = "/var/www/manager/data";
$data_file = "$manager_dir/client_db";
$lock_file = "$manager_dir/.db.lock";

if(symlink($data_file,$lock_file)==0) {
    print "anather instance running\n";
    exit;
}

if ( $command eq "db_dump" ) {
    $db = shift;
    $data_file = "$manager_dir/$db";
}

tie( %client_data, 'AnyDBM_File', $data_file, O_CREAT|O_RDWR, 0600 );

if ( $command eq "add" ) {
    $ip = shift;
    $group = shift;
    $type = shift;
    $config = shift;
    if ( $ip eq "" || $group eq "" || ($type ne "normal" && $type ne "test") || $config eq "" ) {
        print "usage: clinet_db_admin.pl add ip group (normal|test) config\n";
	unlink($lock_file);
        exit(1);
    }
    $addr = inet_aton($ip);
    $host = gethostbyaddr($addr,AF_INET);
    unless ( $host ) {
	print "could nor resolve IP($ip)\n";
	unlink($lock_file);
 	exit(1);
    }
    $client_data{$host} = "$ip,$group,$type,,,,,,,,,,,,,$config";
} elsif ( $command eq "add_list" ) {
    $list = shift;
    if ( ! -f "$manager_dir/$list" ) {
	print "usage: client_db_admin.pl add_list filename\n";
	print " $list not exist $manager_dir\n";
	unlink($lock_file);
	exit(1);
    }
    open(LIST,"$manager_dir/$list");
    while(<LIST>) {
	chomp;
	@D = split(/,/,$_);
	$host = shift(@D);
	$client_data{$host} = join(",",@D);
    }
    close(LIST);
} elsif ( $command eq "del" ) {
    $ip = shift;
    if ( $ip eq "" ) {
        print "usage: clinet_db_admin.pl del ip\n";
	unlink($lock_file);
        exit(1);
    }
    $addr = inet_aton($ip);
    $host = gethostbyaddr($addr,AF_INET);
    unless ( $host ) {
	print "could not resolve IP($ip)\n";
	$host = $ip;
    }
    $data = $client_data{$host};
    if ( $data ) {
        delete $client_data{$host};
        print "data delete complete($data)\n";
    } else {
	print "client data not found($ip:$host)\n";
    }
} elsif ( $command eq "type" ) {
    $ip = shift;
    $type = shift;
    if ( $ip eq "" || ($type ne "normal" && $type ne "test")) {
        print "usage: clinet_db_admin.pl type ip (normal|test)\n";
	unlink($lock_file);
        exit(1);
    }
    $addr = inet_aton($ip);
    $host = gethostbyaddr($addr,AF_INET);
    unless ( $host ) {
	print "could nor resolve IP($ip)\n";
	unlink($lock_file);
 	exit(1);
    }
    @D = split(/,/,$client_data{$host});
    $D[2] = $type;
    $client_data{$host} = join(",",@D);
} elsif ( $command eq "dump" ) {
    $ip = shift;
    if ( $ip eq "" ) {
        print "usage: clinet_db_admin.pl dump ip\n";
	unlink($lock_file);
        exit(1);
    }
    $addr = inet_aton($ip);
    $host = gethostbyaddr($addr,AF_INET);
    unless ( $host ) {
	print "could nor resolve IP($ip)\n";
	unlink($lock_file);
 	exit(1);
    }
    $data = $client_data{$host};
    if ( $data ) {
        print "$host => $client_data{$host}\n";
    } else {
	print "client data not found($ip:$host)\n";
    }
    unlink($lock_file);
    exit(0);
} elsif ( $command eq "list" ) {
    foreach $h ( sort keys %client_data ) {
	print $client_data{$h},"\n";
    }
    unlink($lock_file);
    exit(0);
} elsif ( $command eq "db_dump" ) {
    foreach $h ( sort keys %client_data ) {
	print $client_data{$h},"\n";
    }
    unlink($lock_file);
    exit(0);
} elsif ( $command eq "test" ) {
    foreach $h ( sort keys %client_data ) {
        ($ip) = $client_data{$h} =~ /^(\d+\.\d+\.\d+\.\d+),/;
        ($type) = $client_data{$h} =~ /^.*?,.*?,(normal|test),/;
        if ( $type eq "test" ) {
            print "$ip\n";
        }
    }
    unlink($lock_file);
    exit(0);
} else {
    print "command not found\n";
    unlink($lock_file);
    exit(1);
}

untie(%client_data);
print "OK\n";

$pid = getpwnam("psmtadm");
$gid = getgrnam("psmtadm");
chown($pid,$gid,$data_file);

unlink($lock_file);
exit(0);
