#!/bin/sh
#-------------------------------------------------
# ProScan Management Tool Manager Updater
#
# All Rights Reserved, Copyright (C) Promark Inc. 2022
#
#---- change log
# 2022.02.04 PSMT manager upgrade script
#
MANAGER=$1
PORT=$2
CURRENT_DIR=`pwd`
INSTALL_DIR=/var/www/manager

# param check
if [ "$MANAGER" = "" ]
then
    echo "Usage: manager_updater.sh MANAGER [PORT]"
    exit
fi

if [ "$PORT" = "" ]
then
    PORT=8505
fi

copy_file() {
    SRC=$1
    DST=$2
    sed -e "s/192.168.100.4/$MANAGER/g;s/8505/$PORT/g;s#/var/www/manager#$INSTALL_DIR#g" $SRC > $DST

    # Mode & Owner change
    chmod a+x $DST
    chown psmtadm:psmtadm $DST
}

# Copy module
if [ -d $CURRENT_DIR/bin ]
then
    cd $CURRENT_DIR/bin
    for f in *
    do
        if [ -f $INSTALL_DIR/bin/$f ]
        then
    	cp -p $INSTALL_DIR/bin/$f $INSTALL_DIR/bin/$f.back
        fi
        copy_file $f $INSTALL_DIR/bin/$f
    done
fi
if [ -d $CURRENT_DIR/cgi ]
then
    cd $CURRENT_DIR/cgi
    for f in *
    do
        if [ -f $INSTALL_DIR/cgi/$f ]
        then
    	    cp -p $INSTALL_DIR/cgi/$f $INSTALL_DIR/cgi/$f.back
        fi
        copy_file $f $INSTALL_DIR/cgi/$f
    done
fi
if [ -d $CURRENT_DIR/mirror ]
then
    cd $CURRENT_DIR/mirror
    for f in *
    do
        if [ -f $INSTALL_DIR/mirror/$f ]
        then
	    cp -p $INSTALL_DIR/mirror/$f $INSTALL_DIR/mirror/$f.back
        fi
        copy_file $f $INSTALL_DIR/mirror/$f
    done
fi
